/*
 * Created on 22 avr. 2004 by the Message Center Team
 *
 */

package mc.formgenerator.ggf;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;

import mc.formgenerator.ggf.xslprocessing.XalanExecutor;

import org.w3c.dom.Document;

import java.io.ByteArrayOutputStream; 
import org.apache.xml.serialize.XMLSerializer; 
import org.apache.xml.serialize.OutputFormat; 


/**
 * Implementation of the generic form generator
 * This class will be call by the servletGF
 * @author sempereb
 */
public class GGF{

	//Xalan executor instance for xsl processing
	public XalanExecutor xalanExe;
	
	//Context for the webapp
	public String contextPath = null;
	
	//Action URL
	public String actionURL = null;
	
	//Parameters names
	private Map parameterNames = null;
	

	/**
	 * Default constructor for our class 
	 * @param contextPath Context path for uri resolution
	 * @param actionURL URL for submission
	 * @throws TransformerConfigurationException
	 */
	public GGF(String contextPath, String actionURL, String userLanguage) throws TransformerConfigurationException{
		
		//Setting the context path attribute
		this.contextPath = contextPath;
		
		//Setting the actionURL attribute
		this.actionURL = actionURL;
		
      	// get the file path to XForms display
		String fileXformsBonita = contextPath + File.separator + "web" + File.separator + "xml" + File.separator + "xformsBonita.xml";

		
		//Instanciation of Xalan executor variable
	 	this.xalanExe = new XalanExecutor( this.contextPath + File.separator + "web" + File.separator + "xslt" + File.separator + "generator.xsl", 
	 		userLanguage, fileXformsBonita);
		
		//Parameters names
		this.parameterNames = new HashMap();
		
	}
	 
	public GGF(String contextPath, String actionURL, String xslURI, String userLanguage) 
	throws TransformerConfigurationException{
		
		//Setting the context path attribute
		this.contextPath = contextPath;
		
		//Setting the actionURL attribute
		this.actionURL = actionURL;
		
		// get the file path to XForms display
		String fileXformsBonita = contextPath + File.separator + "web" + File.separator + "xml" + File.separator + "xformsBonita.xml";
		
		//Instanciation of Xalan executor variable
	 	this.xalanExe = XalanExecutor.xalanExecutorFormURL( xslURI , userLanguage, fileXformsBonita);
		
		//Parameters names
		this.parameterNames = new HashMap();
	}
	
	// Retourne un Document en String
	public static String toString(Document doc) throws Exception{
	
	    ByteArrayOutputStream os = new ByteArrayOutputStream();
	    OutputFormat outputFormat = new OutputFormat(doc);
	    outputFormat.setPreserveSpace(true);
	    outputFormat.setIndenting(true);
	    //outputFormat.setLineWidth(0);
	    XMLSerializer serializer = new XMLSerializer(os, outputFormat);
	    serializer.serialize(doc);
	
	    return new String(os.toByteArray());
	 }	

	
	/**
	 * Generates a xhtml dom thanks to the xsl file and the xml dom in input
	 * @param xmlInput: The xml file that will be submit to the xsl transformation
	 * @return a Document, a dom that represents the generated document
	 * @throws XFormsException
	 * @throws TransformerConfigurationException
	 * @throws FileNotFoundException
	 * @throws TransformerException
	 * @throws IOException
	 */
	private Document generateXforms (Document instance, String xmlBase) throws TransformerConfigurationException, FileNotFoundException, TransformerException, IOException{
		//Output Document
		Document xformsOutput;
		
	 	try {
			}
			catch(Exception e){
				System.out.println(e + " " + e.getMessage());
			}		
		
		//Dom tranformation processing
		xformsOutput = this.xalanExe.XalanExecutionDOM(instance,xmlBase);
	
	 	try {
		}
		catch(Exception e){
		}	 				
		
 	
	 	//Return the Xforms document
	 	return xformsOutput;
	 } 
	 
	 
	/**
	 * Generate XForm document 
	 * @param xmlInput: The document send to the xsl engine
	 * @throws TransformerConfigurationException
	 * @throws FileNotFoundException
	 * @throws TransformerException
	 * @throws IOException
	 */
	public Document runGGF(Document instance, String xmlBase) throws TransformerConfigurationException, FileNotFoundException, TransformerException, IOException{
	 	
	 	try {
		}
		catch(Exception e){
		}	 	
	 	
	 	//xforms generation by xsl file and xsl engine
	 	Document xformsDocument = this.generateXforms(instance,xmlBase);
	 	
	 	if(xformsDocument == null){
	 	}
	 	return xformsDocument;
	}


	/**
	 * @param prefix
	 * @return
	 */
	public String getUniqueParameterName(String prefix) {
		String id = prefix + Integer.toHexString((int) (Math.random() * 10000));

		while (this.parameterNames.get(id) != null) {
			id = prefix + Integer.toHexString((int) (Math.random() * 10000));
		}

		return id;
	}

}
