<?xml version='1.0' encoding='UTF-8' standalone='yes'?>

<!--
 indexes all xforms element with an id except xforms:model
 and its descendants.
 
 author: joern turner <joernt@chiba.sourceforge.net>

-->
<xsl:stylesheet version='1.0' xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:template match='/'>
	<xsl:copy>
		<xsl:apply-templates />
	</xsl:copy>
</xsl:template>

<xsl:template match='*|@*|text()|comment'>
	<xsl:copy>
		<xsl:call-template name='copy-attributes'/>
		<xsl:apply-templates/>
	</xsl:copy>
</xsl:template>

<xsl:template match='xforms:*'>
	<xsl:copy>
		<xsl:if test='not(@xforms:id)'>
			<xsl:attribute name='xforms:id'>
				<xsl:value-of select='generate-id()'/>
			</xsl:attribute>
		</xsl:if>
		<xsl:call-template name='copy-attributes'/>
		<xsl:apply-templates/>
	</xsl:copy>
</xsl:template>

<!-- does not index xforms:model and descendants !!! -->
<xsl:template match="xforms:model">
	<xsl:copy-of select="." />
</xsl:template>

<xsl:template name="copy-attributes">
    <xsl:for-each select="@*">
        <xsl:copy/>
    </xsl:for-each> 
</xsl:template>

</xsl:stylesheet>