package hero.entity;

import hero.interfaces.BnProjectConfigLocal;
import hero.interfaces.BnProjectConfigPK;
import hero.interfaces.BnProjectConfigValue;
import hero.interfaces.BnProjectLocal;
import hero.interfaces.InvalidValueException;
import hero.interfaces.Constants;

import hero.util.BonitaServiceLocator;
import hero.util.BonitaServiceException;
import hero.util.values.BonitaConfigValue;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.RemoveException;

/**
 * The Entity bean represents a BnProjectConfig
 *
 * @author Miguel Valdes Faura
 * @version $Revision: 1.6 $
 *
 * @ejb:bean name="BnProjectConfig"
 *           display-name="BnProjectConfig Entity"
 *           type="CMP"
 *           jndi-name="ejb/hero/BnProjectConfig"
 *           local-jndi-name="ejb/hero/BnProjectConfig_L"
 *           view-type="both"
 *           cmp-version="2.x"
 *           reentrant="true"   
 *
 *
 * @ejb:transaction type="Supports"
 *
 * @jonas.bean
 *     ejb-name="BnProjectConfig"
 *     jndi-name="ejb/hero/BnProjectConfig"
 * 	   lock-policy="container-read-committed"
 * @jonas.jdbc-mapping
 *     jndi-name="bonita"
 *     jdbc-table-name="BnProjectConfig"
 * 
 * @jonas.shared false
 *
 * @ejb:finder signature="java.util.Collection findAll()" 
 *     query="SELECT object(a) FROM BnProjectConfig a"
 *     transaction-type="Supports"
 *
 * @ejb.value-object
 *    match="*"
 *    name="BnProjectConfig"
 * 
 * @jboss:table-name table-name="BnProjectConfig"
 *
 * @jboss:create-table create="true"
 *
 * @jboss:remove-table remove="false"
 *
 **/
public abstract class BnProjectConfigBean
   implements EntityBean
{
   
   // -------------------------------------------------------------------------
   // Members
   // -------------------------------------------------------------------------  
   
   public EntityContext mContext;
   
   
   // -------------------------------------------------------------------------
   // Properties (Getters/Setters)
   // -------------------------------------------------------------------------  
   
   /**
   * Retrieve the BnProjectConfig's id.
   *
   * @return Returns an int representing the id of this BnProjectConfig.
   * @ejb:pk-field
   *
   * @ejb:persistence column-name="id"
   * @jonas.cmp-field-jdbc-mapping
   *    field-name="id"
   *    jdbc-field-name="id"
   * @ejb:transaction type="Supports"
   **/
   public abstract String getId();
   
   /**
   * Set the BnProjectConfig's id.
   *
   * @param pId The id of this BnProjectConfig. Is set at creation time.
   * @ejb:transaction type="Required"
  **/
   public abstract void setId( String pId );
   
   /**
   * Retrieve the BnProjectConfig's jms attribute.
   *
   * @return Returns a boolean representing the jms attribute of this BnProjectConfig.
   * @ejb:interface-method view-type="both"
   *
   * @ejb:persistence column-name="jms"
   * @ejb:transaction type="Supports"
   **/
   public abstract boolean getJMS();
   
   /**
   * Set the BnProjectConfig's jms attribute.
   *
   * @param jms The jms attribute of this BnProjectConfig. Is set at creation time.
   * @ejb:interface-method view-type="local"
   * @ejb:transaction type="Required"
  **/
   public abstract void setJMS( boolean jms);
   
   /**
    * Retrieve the BnProjectConfig's log attribute.
    *
    * @return Returns a boolean representing the log attribute of this BnProjectConfig.
    * @ejb:interface-method view-type="both"
    *
    * @ejb:persistence column-name="log"
    * @ejb:transaction type="Supports"
    **/
    public abstract boolean getLog();
    
    /**
    * Set the BnProjectConfig's log attribute.
    *
    * @param log The log attribute of this BnProjectConfig. Is set at creation time.
    * @ejb:interface-method view-type="local"
    * @ejb:transaction type="Required"
   **/
    public abstract void setLog( boolean log);
    
    /**
     * Retrieve the BnProjectConfig's LogLevel attribute.
     *
     * @return Returns a string representing the LogLevel attribute of this BnProjectConfig.
     * @ejb:interface-method view-type="both"
     *
     * @ejb:persistence column-name="loglevel"
     * @ejb:transaction type="Supports"
     **/
     public abstract String getLogLevel();
     
     /**
     * Set the BnProjectConfig's logLevel attribute for the BnProjectConfig (Debug/Info/Error).
     *
     * @param historic The LogLevel attribute of this BnProjectConfig. Is set at creation time.
     * @ejb:interface-method view-type="local"
     * @ejb:transaction type="Required"
    **/
     public abstract void setLogLevel( String traceLevel);    
    
    /**
     * Retrieve the BnProjectConfig's trace.
     *
     * @return Returns a boolean representing the trace attribute of this BnProjectConfig.
     * @ejb:interface-method view-type="both"
     *
     * @ejb:persistence column-name="trace"
     * @ejb:transaction type="Supports"
     **/
     public abstract boolean getTrace();
     
     /**
     * Set the BnProjectConfig's trace attribute.
     *
     * @param trace The trace attribute of this BnProjectConfig. Is set at creation time.
     * @ejb:interface-method view-type="local"
     * @ejb:transaction type="Required"
    **/
     public abstract void setTrace( boolean trace);
     
     /**
      * Retrieve the BnProjectConfig's TraceLevel attribute.
      *
      * @return Returns a string representing the TraceLevel attribute of this BnProjectConfig.
      * @ejb:interface-method view-type="both"
      *
      * @ejb:persistence column-name="tracelevel"
      * @ejb:transaction type="Supports"
      **/
      public abstract String getTraceLevel();
      
      /**
      * Set the BnProjectConfig's traceLevel attribute for the BnProjectConfig (Debug/Info/Error).
      *
      * @ejb:interface-method view-type="local"
      * @param historic The TraceLevel attribute of this BnProjectConfig. Is set at creation time.
      * @ejb:transaction type="Required"
     **/
      public abstract void setTraceLevel( String traceLevel);
    
     /**
      * Retrieve the BnProjectConfig's historic attribute.
      *
      * @return Returns a string representing the historic attribute of this BnProjectConfig.
      * @ejb:interface-method view-type="both"
      *
      * @ejb:persistence column-name="historic"
      * @ejb:transaction type="Supports"
      **/
      public abstract String getHistoric();
      
      /**
      * Set the BnProjectConfig's historic attribute for the BnProjectConfig (Purge/Transfer).
      *
      * @param historic The historic attribute of this BnProjectConfig. Is set at creation time.
      * @ejb:interface-method view-type="local"
      * @ejb:transaction type="Required"
     **/
      public abstract void setHistoric( String historic);
     
    /** Retrieve the project.
	*
	* @return Returns a BnProjectLocal.
	* @ejb:interface-method view-type="both"
	* @ejb:relation name="project-config" role-name=project2config" cascade-delete="yes"
	* @jboss:auto-key-fields
	* @jonas:automatic-pk="true"
	* @ejb:transaction type="Supports"
	**/
    public abstract BnProjectLocal getBnProject();
    
    /**
     * Set the BnProject Name.
     *
     * @param pName The Name of this BnProjectConfig.  Is set at creation time.
     * @ejb:interface-method view-type="local"
     * @ejb:transaction type="Required"
     **/
    public abstract void setBnProject(BnProjectLocal pProject);
     
	/**
	  * @ejb.interface-method 
	  * @ejb:transaction type="Supports"
	  */
	 public abstract BnProjectConfigValue getBnProjectConfigValue();
    
	 /**
	  * @ejb.interface-method 
	  * @ejb:transaction type="Required"
	  */
	 public abstract void setBnProjectConfigValue(BnProjectConfigValue v);
   
   // -------------------------------------------------------------------------
   // Framework Callbacks
   // -------------------------------------------------------------------------  
   
   /**
   * Create a BnProjectConfig based on the supplied BnProjectConfig Value Object.
   *
   *
   * @throws InvalidValueException If one of the values are not correct,
   *                               this will not roll back the transaction
   *                               because the caller has the chance to
   *                               fix the problem and try again
   * @throws EJBException If no new unique ID could be retrieved this will
   *                      rollback the transaction because there is no
   *                      hope to try again
   * @throws CreateException Because we have to do so (EJB spec.)
   *
   * @ejb:create-method view-type="both"
   **/
   public BnProjectConfigPK ejbCreate(BonitaConfigValue project, String instance) throws InvalidValueException, EJBException, CreateException
   {
   	if (instance.matches(".*_instance.*"))
   	{   		
   		this.setJMS(project.getJms());
   	   	this.setLog(project.getLog());
   	   	this.setTrace(project.getTrace());
   	   	this.setHistoric(project.getHistoric());
   	   	this.setLogLevel(project.getLogLevel());
   	   	this.setTraceLevel(project.getTraceLevel());
   	   	this.setId(hero.interfaces.BnProjectConfigUtil.generateGUID(this));
   	}
   	else
   	{
   		this.setJMS(true);
   		this.setLog(true);
   		this.setTrace(true);
   		this.setHistoric(Constants.TRANSFER);
   		this.setLogLevel(Constants.DEBUG);
   		this.setTraceLevel(Constants.DEBUG);
   		this.setId(hero.interfaces.BnProjectConfigUtil.generateGUID(this));
   	}
	  		
      return null;
   }

   
   /**
   * Create a BnProjectConfig based on the supplied BnProjectConfig Value Object.
   *
   *
   * @throws InvalidValueException If one of the values are not correct,
   *                               this will not roll back the transaction
   *                               because the caller has the chance to
   *                               fix the problem and try again
   * @throws EJBException If no new unique ID could be retrieved this will
   *                      rollback the transaction because there is no
   *                      hope to try again
   * @throws CreateException Because we have to do so (EJB spec.)
   *
   * @ejb:create-method view-type="both"
   **/
   public BnProjectConfigPK ejbCreate() throws InvalidValueException, EJBException, CreateException
   {
   		this.setJMS(true);
   		this.setLog(true);
   		this.setTrace(true);
   		this.setHistoric(Constants.TRANSFER);
   		this.setLogLevel(Constants.DEBUG);
   		this.setTraceLevel(Constants.DEBUG);
   		this.setId(hero.interfaces.BnProjectConfigUtil.generateGUID(this));   		  		
      return null;
   }
   
   /**
   * Create a BnProjectConfig based on the supplied BnProjectConfig Value Object. (c'est merdique)
   *
   *
   * @throws InvalidValueException If one of the values are not correct,
   *                               this will not roll back the transaction
   *                               because the caller has the chance to
   *                               fix the problem and try again
   * @throws EJBException If no new unique ID could be retrieved this will
   *                      rollback the transaction because there is no
   *                      hope to try again
   * @throws CreateException Because we have to do so (EJB spec.)
   *
   * @ejb:create-method view-type="both"
   **/
   public BnProjectConfigPK ejbCreate(BnProjectConfigValue pProjectConfig)
      throws
         CreateException
   {
       this.setBnProjectConfigValue(pProjectConfig);
       this.setId(hero.interfaces.BnProjectConfigUtil.generateGUID(this));
	   
       return null;
   }

   
   public void ejbPostCreate( )
   {
   }
   
   public void setEntityContext( EntityContext lContext )
   {
      mContext = lContext;
   }
   
   public void unsetEntityContext()
   {
      mContext = null;
   }
   
   public void ejbActivate()
   {
   }
   
   public void ejbPassivate()
   {
   }
   
   public void ejbLoad()
   {
   }
   
   public void ejbStore()
   {
   }
   
   public void ejbRemove()
      throws
         RemoveException
   {
   }

}
